// -------------------------------------------------------------------------------
// 
// 		cwCu		\tgEFAň摜vO
// 
// 				Ver 3.11b
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxSoftImage.h"

#ifndef DX_NON_SOFTIMAGE

#include "DxStatic.h"
#include "DxLib.h"
#include "DxASyncLoad.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxFile.h"
#include "DxSystem.h"
#include "DxLog.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

SOFTIMAGEMANAGE SoftImageManage ;

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// An

// {C[WǗ̏
extern int InitializeSoftImageManage( void )
{
	// ɏĂ牽Ȃ
	if( SoftImageManage.InitializeFlag == TRUE )
		return -1 ;

	// \tgC[WnhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_SOFTIMAGE, sizeof( SOFTIMAGE ), MAX_SOFTIMAGE_NUM, InitializeSoftImageHandle, TerminateSoftImageHandle, DXSTRING( _T( "\tgC[W" ) ) ) ;

	// tO𗧂Ă
	SoftImageManage.InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// {C[WǗ̌n
extern int TerminateSoftImageManage( void )
{
	// ɌnĂ牽Ȃ
	if( SoftImageManage.InitializeFlag == FALSE )
		return -1 ;

	// tO|
	SoftImageManage.InitializeFlag = FALSE ;

	// \tgC[WnhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_SOFTIMAGE ) ;

	// I
	return 0 ;
}










// \tgEGAC[Wnh̏
extern int InitializeSoftImageHandle( HANDLEINFO * )
{
	// ɉȂ
	return 0 ;
}

// \tgEGAC[Wnȟn
extern int TerminateSoftImageHandle( HANDLEINFO *HandleInfo )
{
	SOFTIMAGE *SoftImg = ( SOFTIMAGE * )HandleInfo ;

	// 摜f[^̉
	NS_ReleaseBaseImage( &SoftImg->BaseImage ) ;

	// I
	return 0 ;
}

// \tgEGAňC[WSĉ
extern int NS_InitSoftImage( void )
{
	return AllHandleSub( DX_HANDLETYPE_SOFTIMAGE ) ;
}

// LoadSoftImage ̎֐
static int LoadSoftImage_Static(
	int SIHandle,
	const TCHAR *FileName,
	int ASyncThread
)
{
	SOFTIMAGE *SoftImg ;

	// V\tgC[Wnh̎擾
	if( ASyncThread )
	{
		if( SFTIMGCHK_ASYNC( SIHandle, SoftImg ) )
			return -1 ;
	}
	else
	{
		if( SFTIMGCHK( SIHandle, SoftImg ) )
			return -1 ;
	}

	// CreateBaseImageToFile Ńt@Cǂݍ
	if( NS_CreateBaseImageToFile( FileName, &SoftImg->BaseImage, FALSE ) == -1 )
		return -1 ;

	// I
	return 0 ;
}

#ifndef DX_NON_ASYNCLOAD

// LoadSoftImage ̔񓯊ǂݍ݃XbhĂ΂֐
static void LoadSoftImage_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int SIHandle ;
	const TCHAR *FileName ;
	int Addr ;
	int Result ;

	Addr = 0 ;
	SIHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	FileName = GetASyncLoadParamString( AParam->Data, &Addr ) ;

	Result = LoadSoftImage_Static( SIHandle, FileName, TRUE ) ;

	DecASyncLoadCount( SIHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteSoftImage( SIHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// LoadSoftImage ̃O[oϐɃANZXȂo[W
extern int LoadSoftImage_UseGParam(
	const TCHAR *FileName,
	int ASyncLoadFlag
)
{
	int SIHandle ;

	CheckActiveState() ;

	// nh̍쐬
	SIHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( SIHandle == -1 ) return -1 ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		TCHAR FullPath[ 1024 ] ;
		int Addr ;

		ConvertFullPathT_( FileName, FullPath ) ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, SIHandle ) ;
		AddASyncLoadParamString( NULL, &Addr, FullPath ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = LoadSoftImage_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SIHandle ) ;
		AddASyncLoadParamString( AParam->Data, &Addr, FullPath ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( SIHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( LoadSoftImage_Static( SIHandle, FileName, FALSE ) < 0 )
			goto ERR ;
	}

	// I
	return SIHandle ;

ERR :
	NS_DeleteSoftImage( SIHandle ) ;

	return -1 ;
}

// \tgEGAňC[W̓ǂݍ( -1:G[  -1ȊO:C[Wnh )
extern	int		NS_LoadSoftImage( const TCHAR *FileName )
{
	return LoadSoftImage_UseGParam( FileName, GetASyncLoadFlag() ) ;
}

// LoadSoftImageToMem ̎֐
static int LoadSoftImageToMem_Static(
	int SIHandle,
	const void *FileImage,
	int FileImageSize,
	int ASyncThread
)
{
	SOFTIMAGE *SoftImg ;

	// V\tgC[Wnh̎擾
	if( ASyncThread )
	{
		if( SFTIMGCHK_ASYNC( SIHandle, SoftImg ) )
			return -1 ;
	}
	else
	{
		if( SFTIMGCHK( SIHandle, SoftImg ) )
			return -1 ;
	}

	// CreateBaseImageToMem Ńǂݍ
	if( NS_CreateBaseImageToMem( FileImage, FileImageSize, &SoftImg->BaseImage, FALSE ) == -1 )
		return -1 ;

	// I
	return 0 ;
}

#ifndef DX_NON_ASYNCLOAD

// LoadSoftImageToMem ̔񓯊ǂݍ݃XbhĂ΂֐
static void LoadSoftImageToMem_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int SIHandle ;
	const void *FileImage ;
	int FileImageSize ;
	int Addr ;
	int Result ;

	Addr = 0 ;
	SIHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	FileImage = GetASyncLoadParamVoidP( AParam->Data, &Addr ) ;
	FileImageSize = GetASyncLoadParamInt( AParam->Data, &Addr ) ;

	Result = LoadSoftImageToMem_Static( SIHandle, FileImage, FileImageSize, TRUE ) ;

	DecASyncLoadCount( SIHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteSoftImage( SIHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD


// LoadSoftImageToMem ̃O[oϐɃANZXȂo[W
extern int LoadSoftImageToMem_UseGParam(
	const void *FileImage,
	int FileImageSize,
	int ASyncLoadFlag
)
{
	int SIHandle ;

	CheckActiveState() ;

	// nh̍쐬
	SIHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( SIHandle == -1 ) return -1 ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, SIHandle ) ;
		AddASyncLoadParamConstVoidP( NULL, &Addr, FileImage ) ;
		AddASyncLoadParamInt( NULL, &Addr, FileImageSize ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = LoadSoftImageToMem_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, SIHandle ) ;
		AddASyncLoadParamConstVoidP( AParam->Data, &Addr, FileImage ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, FileImageSize ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( SIHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( LoadSoftImageToMem_Static( SIHandle, FileImage, FileImageSize, FALSE ) < 0 )
			goto ERR ;
	}

	// I
	return SIHandle ;

ERR :
	NS_DeleteSoftImage( SIHandle ) ;

	return -1 ;
}

// \tgEGAňC[W̃̓ǂݍ( -1:G[  -1ȊO:C[Wnh )
extern	int		NS_LoadSoftImageToMem( const void *FileImage, int FileImageSize )
{
	return LoadSoftImageToMem_UseGParam( FileImage, FileImageSize, GetASyncLoadFlag() ) ;
}

// \tgEGAňC[W̍쐬( -1:G[  -1ȊO:C[Wnh )
extern	int		NS_MakeSoftImage( int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;
	int NewHandle ;

	// V\tgC[Wnh̎擾
	NewHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( NewHandle == -1 ) return -1 ;
	if( SFTIMGCHK( NewHandle, SoftImg ) )
		return -1 ;

	// CreateARGB8ColorBaseImage gp
	if( NS_CreateARGB8ColorBaseImage( SizeX, SizeY, &SoftImg->BaseImage ) == -1 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// \tgEGAňC[W̍쐬( RGBA8 J[ )
extern	int		NS_MakeARGB8ColorSoftImage( int SizeX, int SizeY )
{
	// NS_MakeSoftImage Ɠ
	return NS_MakeSoftImage( SizeX, SizeY ) ;
}

// \tgEGAňC[W̍쐬( XRGB8 J[ )
extern	int		NS_MakeXRGB8ColorSoftImage( int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;
	int NewHandle ;

	// V\tgC[Wnh̎擾
	NewHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( NewHandle == -1 ) return -1 ;
	if( SFTIMGCHK( NewHandle, SoftImg ) )
		return -1 ;

	// CreateXRGB8ColorBaseImage gp
	if( NS_CreateXRGB8ColorBaseImage( SizeX, SizeY, &SoftImg->BaseImage ) == -1 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// \tgEGAňC[W̍쐬( ARGB4 J[ )
extern	int		NS_MakeARGB4ColorSoftImage( int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;
	int NewHandle ;

	// V\tgC[Wnh̎擾
	NewHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( NewHandle == -1 ) return -1 ;
	if( SFTIMGCHK( NewHandle, SoftImg ) )
		return -1 ;

	// CreateARGB4ColorBaseImage gp
	if( NS_CreateARGB4ColorBaseImage( SizeX, SizeY, &SoftImg->BaseImage ) == -1 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// \tgEGAňC[W̍쐬( RGB8 J[ )
extern	int		NS_MakeRGB8ColorSoftImage( int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;
	int NewHandle ;

	// V\tgC[Wnh̎擾
	NewHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( NewHandle == -1 ) return -1 ;
	if( SFTIMGCHK( NewHandle, SoftImg ) )
		return -1 ;

	// CreateRGB8ColorBaseImage gp
	if( NS_CreateRGB8ColorBaseImage( SizeX, SizeY, &SoftImg->BaseImage ) == -1 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// \tgEGAňC[W̍쐬( pbgQTUF J[ )
extern	int		NS_MakePAL8ColorSoftImage( int SizeX, int SizeY )
{
	SOFTIMAGE *SoftImg ;
	int NewHandle ;

	// V\tgC[Wnh̎擾
	NewHandle = AddHandle( DX_HANDLETYPE_SOFTIMAGE ) ;
	if( NewHandle == -1 ) return -1 ;
	if( SFTIMGCHK( NewHandle, SoftImg ) )
		return -1 ;

	// CreatePAL8ColorBaseImage gp
	if( NS_CreatePAL8ColorBaseImage( SizeX, SizeY, &SoftImg->BaseImage ) == -1 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// \tgEGAňC[W̉
extern	int		NS_DeleteSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;
	
	// nh̉
	SubHandle( SIHandle ) ; 

	// I
	return 0 ;
}

// \tgEGAňC[W̃TCY擾
extern	int		NS_GetSoftImageSize( int SIHandle, int *Width, int *Height )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	if( Width  ) *Width  = SoftImg->BaseImage.Width ;
	if( Height ) *Height = SoftImg->BaseImage.Height ;

	// I
	return 0 ;
}

// \tgEGAňC[Wpbg摜ǂ擾( TRUE:pbg摜  FALSE:pbg摜Ȃ )
extern	int		NS_CheckPaletteSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return SoftImg->BaseImage.ColorData.PixelByte == 1 ? TRUE : FALSE ;
}

// \tgEGAňC[W̃tH[}bgɃvf邩ǂ擾( TRUE:  FALSE:Ȃ )
extern	int		NS_CheckAlphaSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return SoftImg->BaseImage.ColorData.AlphaMask != 0 && SoftImg->BaseImage.ColorData.PixelByte >= 2 ? TRUE : FALSE ;
}

// `Ώۂ̉ʂẅ̃OtBbN\tgEGAňC[Wɓ]
extern	int		NS_GetDrawScreenSoftImage( int x1, int y1, int x2, int y2, int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_GetDrawScreenBaseImage( x1, y1, x2, y2, &SoftImg->BaseImage ) ;
}

#ifdef __WINDOWS__

// \tgEGAňC[Wgp UpdateLayerdWindow s( C[W̓EChẼNCAg̈ƓTCYłKv܂ )
extern	int		NS_UpdateLayerdWindowForSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_UpdateLayerdWindowForBaseImage( &SoftImg->BaseImage ) ;
}

// Zς݃At@̃\tgEGAňC[Wgp UpdateLayerdWindow s( C[W̓EChẼNCAg̈ƓTCYłKv܂ )
extern	int		NS_UpdateLayerdWindowForPremultipliedAlphaSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_UpdateLayerdWindowForPremultipliedAlphaBaseImage( &SoftImg->BaseImage ) ;
}

#endif // __WINDOWS__

// \tgEGAňC[WwFœhԂ
extern	int		NS_FillSoftImage( int SIHandle, int r, int g, int b, int a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_FillBaseImage( &SoftImg->BaseImage, r, g, b, a ) ;
}

// \tgEGAňC[W̎ẅ̗ONA
extern	int		NS_ClearRectSoftImage( int SIHandle, int x, int y, int w, int h )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ClearRectBaseImage( &SoftImg->BaseImage, x, y, w, h ) ;
}

// \tgEGAňC[W̃pbg擾
extern	int		NS_GetPaletteSoftImage( int SIHandle, int PaletteNo, int *r, int *g, int *b, int *a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_GetPaletteBaseImage( &SoftImg->BaseImage, PaletteNo, r, g, b, a ) ;
}

// \tgEGAňC[W̃pbgZbg
extern	int		NS_SetPaletteSoftImage( int SIHandle, int PaletteNo, int  r, int  g, int  b, int  a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SetPaletteBaseImage( &SoftImg->BaseImage, PaletteNo, r, g, b, a ) ;
}

// \tgEGAňC[W̎wWɃhbg`悷
extern	int		NS_DrawPixelSoftImage( int SIHandle, int x, int y, int  r, int  g, int  b, int  a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SetPixelBaseImage( &SoftImg->BaseImage, x, y, r, g, b, a ) ;
}

// \tgEGAňC[W̎wWɃhbg`悷
extern	void	NS_DrawPixelSoftImage_Unsafe_XRGB8( int SIHandle, int x, int y, int  r, int  g, int  b )
{
	BASEIMAGE *BaseImage = &( ( SOFTIMAGE * )HandleManageArray[ DX_HANDLETYPE_SOFTIMAGE ].Handle[ SIHandle & DX_HANDLEINDEX_MASK ] )->BaseImage ;

	*((DWORD *)((BYTE *)BaseImage->GraphData + BaseImage->Pitch * y + x * 4)) = ( DWORD )( ( r << 16 ) | ( g << 8 ) | b ) ;
}

// \tgEGAňC[W̎wWɃhbg`悷
extern	void	NS_DrawPixelSoftImage_Unsafe_ARGB8( int SIHandle, int x, int y, int  r, int  g, int  b, int a )
{
	BASEIMAGE *BaseImage = &( ( SOFTIMAGE * )HandleManageArray[ DX_HANDLETYPE_SOFTIMAGE ].Handle[ SIHandle & DX_HANDLEINDEX_MASK ] )->BaseImage ;

	*((DWORD *)((BYTE *)BaseImage->GraphData + BaseImage->Pitch * y + x * 4)) = ( DWORD )( ( a << 24 ) | ( r << 16 ) | ( g << 8 ) | b ) ;
}

// \tgEGAňC[W̎wWɃhbg`悷(pbg摜pALl͂O`QTT)
extern	int		NS_DrawPixelPalCodeSoftImage( int SIHandle, int x, int y, int palNo )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SetPixelPalCodeBaseImage( &SoftImg->BaseImage,  x,  y,  palNo ) ;
}

// \tgEGAňC[W̎wW̐FR[h擾(pbg摜pA߂l͂O`QTT)
extern	int		NS_GetPixelPalCodeSoftImage( int SIHandle, int x, int y )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_GetPixelPalCodeBaseImage( &SoftImg->BaseImage,  x,  y ) ;
}

// \tgEGAňC[W̎C[Wi[Ă郁̈̐擪AhX擾
extern void *NS_GetImageAddressSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return NULL ;

	return SoftImg->BaseImage.GraphData ;
}

// \tgEGAC[Wnh̃Ɋi[Ă摜f[^1Cӂ̃oCg擾
extern int NS_GetPitchSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return NULL ;

	return SoftImg->BaseImage.Pitch ;
}

// \tgEGAňC[W̎wW̐F擾
extern	int		NS_GetPixelSoftImage(  int SIHandle, int x, int y, int *r, int *g, int *b, int *a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_GetPixelBaseImage( &SoftImg->BaseImage, x, y, r, g, b, a ) ;
}

// \tgEGAňC[W̎wW̐F擾
extern	void		NS_GetPixelSoftImage_Unsafe_XRGB8(  int SIHandle, int x, int y, int *r, int *g, int *b )
{
	BASEIMAGE *BaseImage = &( ( SOFTIMAGE * )HandleManageArray[ DX_HANDLETYPE_SOFTIMAGE ].Handle[ SIHandle & DX_HANDLEINDEX_MASK ] )->BaseImage ;
	DWORD Color ;

	Color = *((DWORD *)((BYTE *)BaseImage->GraphData + BaseImage->Pitch * y + x * 4))  ;
	*r = ( Color >> 16 ) & 0xff ;
	*g = ( Color >>  8 ) & 0xff ;
	*b =   Color         & 0xff ;
}

// \tgEGAňC[W̎wW̐F擾
extern	void		NS_GetPixelSoftImage_Unsafe_ARGB8(  int SIHandle, int x, int y, int *r, int *g, int *b, int *a )
{
	BASEIMAGE *BaseImage = &( ( SOFTIMAGE * )HandleManageArray[ DX_HANDLETYPE_SOFTIMAGE ].Handle[ SIHandle & DX_HANDLEINDEX_MASK ] )->BaseImage ;
	DWORD Color ;

	Color = *((DWORD *)((BYTE *)BaseImage->GraphData + BaseImage->Pitch * y + x * 4))  ;
	*a = ( Color >> 24 ) & 0xff ;
	*r = ( Color >> 16 ) & 0xff ;
	*g = ( Color >>  8 ) & 0xff ;
	*b =   Color         & 0xff ;
}

// \tgEGAňC[W̎wWɐ`悷(eFvf͂O`QTT)
extern int NS_DrawLineSoftImage(  int SIHandle, int x1, int y1, int x2, int y2, int r, int g, int b, int a )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_DrawLineBaseImage( &SoftImg->BaseImage, x1, y1, x2, y2, r, g, b, a ) ;
}

// \tgEGAňC[Wʂ̃C[Wɓ]
extern	int		NS_BltSoftImage( int SrcX, int SrcY, int SrcSizeX, int SrcSizeY, int SrcSIHandle, int DestX, int DestY, int DestSIHandle )
{
	SOFTIMAGE *SrcSoftImg, *DestSoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SrcSIHandle,  SrcSoftImg ) ) 
		return -1 ;
	if( SFTIMGCHK( DestSIHandle, DestSoftImg ) )
		return -1 ;

	return NS_BltBaseImage( SrcX, SrcY, SrcSizeX, SrcSizeY, DestX, DestY, &SrcSoftImg->BaseImage, &DestSoftImg->BaseImage ) ;
}

// \tgEGAňC[W𓧉ߐFtœ]
extern	int		NS_BltSoftImageWithTransColor( int SrcX, int SrcY, int SrcSizeX, int SrcSizeY, int SrcSIHandle, int DestX, int DestY, int DestSIHandle, int Tr, int Tg, int Tb, int Ta )
{
	SOFTIMAGE *SrcSoftImg, *DestSoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SrcSIHandle,  SrcSoftImg ) ) 
		return -1 ;
	if( SFTIMGCHK( DestSIHandle, DestSoftImg ) )
		return -1 ;

	return NS_BltBaseImageWithTransColor( SrcX, SrcY, SrcSizeX, SrcSizeY, DestX, DestY, &SrcSoftImg->BaseImage, &DestSoftImg->BaseImage, Tr, Tg, Tb, Ta ) ;
}

// \tgEGAňC[WAt@l̃uhlœ]( Opacity ͓x : 0( S ) ` 255( Ss ) )( o͐悪 ARGB8 `ȊȌꍇ̓G[ɂȂ܂ )
extern	int		NS_BltSoftImageWithAlphaBlend( int SrcX, int SrcY, int SrcSizeX, int SrcSizeY, int SrcSIHandle, int DestX, int DestY, int DestSIHandle, int Opacity )
{
	SOFTIMAGE *SrcSoftImg, *DestSoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SrcSIHandle,  SrcSoftImg ) ) 
		return -1 ;
	if( SFTIMGCHK( DestSIHandle, DestSoftImg ) )
		return -1 ;

	return NS_BltBaseImageWithAlphaBlend( SrcX, SrcY, SrcSizeX, SrcSizeY, DestX, DestY, &SrcSoftImg->BaseImage, &DestSoftImg->BaseImage, Opacity ) ;
}

// \tgEGAňC[W̍E𔽓]
extern	int		NS_ReverseSoftImageH( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReverseBaseImageH( &SoftImg->BaseImage ) ;
}

// \tgEGAňC[W̏㉺𔽓]
extern	int		NS_ReverseSoftImageV( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReverseBaseImageV( &SoftImg->BaseImage ) ;
}

// \tgEGAňC[W̏㉺E𔽓]
extern	int		NS_ReverseSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_ReverseBaseImage( &SoftImg->BaseImage ) ;
}

// \tgEGAňC[WɊ܂܂sNZ̃At@l`FbN( ߂l   0:摜ɃAt@  1:摜ɃAt@Aׂčő(255)l  2:摜ɃAt@A݂At@l͍ŏ(0)ƍő(255)̂݁@3:摜ɃAt@AŏƍőȊO̒Ԃ̒l )  
extern	int		NS_CheckPixelAlphaSoftImage( int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_CheckPixelAlphaBaseImage( &SoftImg->BaseImage ) ;
}

#ifndef DX_NON_FONT

// \tgEGAňC[WɕC[W]
extern	int		NS_BltStringSoftImage( 
						int x, int y, const TCHAR *StrData,
						int DestSIHandle, int DestEdgeSIHandle,
						int VerticalFlag )
{
	SOFTIMAGE *SoftImg, *EdgeSoftImg = NULL ;

	// AhX̎擾
	if( SFTIMGCHK( DestSIHandle, SoftImg ) )
		return -1 ;
	if( DestEdgeSIHandle != -1 )
	{
		if( SFTIMGCHK( DestEdgeSIHandle, EdgeSoftImg ) )
			return -1 ;
	}

	return NS_FontBaseImageBlt( x, y, StrData, &SoftImg->BaseImage, DestEdgeSIHandle != -1 ? &EdgeSoftImg->BaseImage : NULL, VerticalFlag ) ;
}

// \tgEGAňC[WɕC[W]( tHgnhgp )
extern	int		NS_BltStringSoftImageToHandle( 
						int x, int y, const TCHAR *StrData,
						int DestSIHandle, int DestEdgeSIHandle,
						int FontHandle, int VerticalFlag )
{
	SOFTIMAGE *SoftImg, *EdgeSoftImg = NULL ;

	// AhX̎擾
	if( SFTIMGCHK( DestSIHandle, SoftImg ) )
		return -1 ;
	if( DestEdgeSIHandle != -1 )
	{
		if( SFTIMGCHK( DestEdgeSIHandle, EdgeSoftImg ) )
			return -1 ;
	}

	return NS_FontBaseImageBltToHandle( x, y, StrData, &SoftImg->BaseImage, DestEdgeSIHandle != -1 ? &EdgeSoftImg->BaseImage : NULL, FontHandle, VerticalFlag ) ;
}

#endif // DX_NON_FONT


// \tgEGAňC[Wʂɕ`悷
extern	int		NS_DrawSoftImage( int x, int y, int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_DrawBaseImage( x, y, &SoftImg->BaseImage ) ;
}

#ifndef DX_NON_SAVEFUNCTION

// \tgEGAňC[Walo摜t@CƂĕۑ
extern	int		NS_SaveSoftImageToBmp( const TCHAR *FilePath, int SIHandle )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SaveBaseImageToBmp( FilePath, &SoftImg->BaseImage ) ;
}

#ifndef DX_NON_PNGREAD
// \tgEGAňC[Womf摜t@CƂĕۑ
extern	int		NS_SaveSoftImageToPng( const TCHAR *FilePath, int SIHandle, int CompressionLevel )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SaveBaseImageToPng( FilePath, &SoftImg->BaseImage, CompressionLevel ) ;
}
#endif

#ifndef DX_NON_JPEGREAD
// \tgEGAňC[Wiodf摜t@CƂĕۑ
extern	int		NS_SaveSoftImageToJpeg( const TCHAR *FilePath, int SIHandle, int Quality, int Sample2x1 )
{
	SOFTIMAGE *SoftImg ;

	// AhX̎擾
	if( SFTIMGCHK( SIHandle, SoftImg ) )
		return -1 ;

	return NS_SaveBaseImageToJpeg( FilePath, &SoftImg->BaseImage, Quality, Sample2x1 ) ;
}
#endif

#endif // DX_NON_SAVEFUNCTION


}

#endif // DX_NON_SOFTIMAGE
